Generic Streaming app
===========================================

Allows use features of Streaming, Generic Streaming and Message Durability

Installation and Usage
----------------------

Import the demo project into Anypoint Studio.

Fill in all the values in `/main/app/mule-app.properties`

Run the demo project in Studio.

The project contains 5 flows that show some of the use scenarios for the generic streaming feature from Salesforce.
Two of the flows are showing the Outbound use, and the other three are showing the Inbound use scenarios.

Within the browser hit `http://localhost:8081`. The result would be a website that consists of two operations (Publish Streaming Channel and Push Generic Event).

**Flows information**

*salesforce\_generic\_streaming\_template*: This is our main flow. The result of this flow will be the rendering of our form.html.

1. *publish\_streaming\_channel*.
This flow allows you to create a streaming channel on Salesforce.You have to specify the name for the streaming channel, an optional owner id and a short description.

2. *push\_generic\_event*.
This flow allows you to push a list of custom events to a specific streaming channel. All users subscribed to that channel will receive it.

3. *replay\_streaming\_channel*.
Salesforce stores all sent events from the last 24 hours, and assign for each stored event a number - replayId (Message Durability).
This flow allows you to replay stored events.
By selecting ALL replay option, you will be able to see all stored events.
The ONLY-NEW option will allow you to see only those events pushed after you subscribe.
The REPLAY_FROM_ID option allows you to replay events that have the replayId number greater that the value you provide.

4. *replay\_topic*.
This flow works exactly as the replay\_streaming\_channel but for record-related evemts that are pushed in topics.
Same replay options are available.

5. *subscribe\_streaming\_channel*.
This flow allows you to create a subscription toa specific streaming channel. By performing a simple subscription you will only be able to see the events that are pushed on the channel after the subscription.(No replay)